#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP Module (Anti Flash)",
	author	= "wS",
	version = "1.1"
};

new const String:g_sItemName[] = "anti_flash";
new g_ItemID, g_FlashDurationOffs, g_FlashAlphaOffs;
new bool:g_bAccess[MAXPLAYERS + 1];

public OnPluginStart()
{
	if ((g_FlashDurationOffs = FindSendPropOffs("CCSPlayer", "m_flFlashDuration")) == -1)
		SetFailState("m_flFlashDuration not found (FindSendPropOffs)");

	if ((g_FlashAlphaOffs = FindSendPropOffs("CCSPlayer", "m_flFlashMaxAlpha")) == -1)
		SetFailState("m_flFlashMaxAlpha not found (FindSendPropOffs)");

	if ((g_ItemID = VIP_RegisterItem(g_sItemName, true, true)) < 1)
		SetFailState("VIP_RegisterItem error");

	HookEvent("player_blind", player_blind, EventHookMode_Post);
}

public OnPluginEnd()
{
	VIP_UnRegisterItem(g_sItemName);
}

public OnClientConnected(client)
{
	g_bAccess[client] = false;
}

public VIP_OnClientAuthorized(client, const String:steamid[], bool:vip, const String:group[])
{
	if (vip) wS_Check(client);
}

public VIP_OnVipItemToggled(client, ItemID, const String:ItemName[], const String:ItemInfo[], bool:enabled)
{
	if (ItemID == g_ItemID)
	{
		g_bAccess[client] = enabled;
		VIP_ShowMenu(client);
	}
}

public VIP_OnRemoved(client, const String:steamid[], const String:reason[])
{
	g_bAccess[client] = false;
}

public VIP_OnGroupChanged(client, const String:steamid[], const String:OldGroup[], const String:NewGroup[])
{
	g_bAccess[client] = false;
	wS_Check(client);
}

public VIP_OnAdded(client, const String:steamid[], const String:group[], min, const String:admin_steamid[])
{
	if (client > 0) wS_Check(client);
}

wS_Check(client)
{
	if (!VIP_ItemDisabled(g_sItemName) && VIP_GetItemToggledStatus(client, g_sItemName))
	{
		decl String:ItemInfo[MAX_ITEMINFO_LENGTH];
		if (VIP_GetClientItemInfo(client, g_sItemName, ItemInfo))
			g_bAccess[client] = true;
	}
}

public player_blind(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (g_bAccess[client])
	{
		SetEntDataFloat(client, g_FlashAlphaOffs, 0.0);
		SetEntDataFloat(client, g_FlashDurationOffs, 0.0);
	}
}